﻿namespace ConsoleApp1
{
    internal class AsyncMutex2
    {
        Mutex _m;

        public AsyncMutex2()
        {
            _m = new Mutex(false);
        }

        public AsyncMutex2(string name)
        {
            _m = new Mutex(false, name);
        }

        public Task AcquireAsync()
        {
            TaskCompletionSource taskCompletionSource = new();
            ThreadPool.RegisterWaitForSingleObject(_m, signalWork, taskCompletionSource, -1, true);
            return taskCompletionSource.Task;
        }

        public void Release()
        {
            _m.ReleaseMutex();
        }

        void signalWork(object? state, bool timedOut)
        {
            if (state is TaskCompletionSource taskSource)
            {
                taskSource.SetResult();
            }
        }
    }
}
