﻿namespace ConsoleApp1
{
    internal class AsyncMutex2 : IAsyncDisposable
    {
        Semaphore _smp;
        bool _timedOut = false;
        public bool TimedOut => _timedOut;

        public AsyncMutex2(string name)
        {
            _smp = new Semaphore(1, 1, name);
        }

        public Task AcquireAsync()
        {
            return AcquireAsync(-1);
        }

        public Task AcquireAsync(int millisecondsTimeOutInterval)
        {
            TaskCompletionSource taskCompletionSource = new();

            ThreadPool.RegisterWaitForSingleObject(_smp, signalWork, taskCompletionSource, millisecondsTimeOutInterval, true);
            return taskCompletionSource.Task;
        }

        public void Release()
        {
            _smp.Release();
        }

        void signalWork(object? state, bool timedOut)
        {
            if (state is TaskCompletionSource taskSource)
            {
                if (timedOut)
                {
                    taskSource.SetCanceled();
                    return;
                }

                taskSource.SetResult();
            }
        }

        public ValueTask DisposeAsync()
        {
            _smp.Dispose();
            return ValueTask.CompletedTask;
        }
    }
}
