﻿namespace ConsoleApp1
{
    internal class Program
    {
        static AsyncMutex2 m = new AsyncMutex2(@"Global\MyMutex");

        static async Task Main(string[] args)
        {
            await using (m)
            {
                Task t1 = Task.Run(async () =>
                {
                    await PrintOut(1);
                });

                Task t2 = Task.Run(async () =>
                {
                    await PrintOut(2);
                });

                Task t3 = Task.Run(async () =>
                {
                    await PrintOut(3, 1000);
                });

                try
                {
                    Task.WaitAll(t1, t2, t3);
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex.Message);
                }

                Task t4 = Task.Run(async () =>
                {
                    await PrintOut(4);
                });

                Task t5 = Task.Run(async () =>
                {
                    await PrintOut(5);
                });

                Task.WaitAll(t4, t5);
            }
        }

        static async Task PrintOut(int workId)
        {
            await PrintOut(workId, -1);
        }

        static async Task PrintOut(int workId, int timeOut)
        {
            await m.AcquireAsync(timeOut);
            Console.WriteLine($"{DateTime.Now} {workId} [{Thread.CurrentThread.ManagedThreadId}]: PrintOut-EX-before");
            Thread.Sleep(2000);
            Console.WriteLine($"{DateTime.Now} {workId} [{Thread.CurrentThread.ManagedThreadId}]: PrintOut-EX-after");
            m.Release();
        }
    }
}